uint8_t MAC_array[6];
char MAC_char[12 + 1] = {0};

// DNS server
const byte DNS_PORT = 53;
DNSServer dnsServer;

// Web server
ESP8266WebServer server(80);

/* Soft AP network parameters */
IPAddress apIP(192, 168, 4, 1);
IPAddress netMsk(255, 255, 255, 0);

boolean is_connected = false;

/** Current WLAN status */
int status = WL_IDLE_STATUS;

boolean captivePortal() {
  if (!isIp(server.hostHeader()) && server.hostHeader() != (String(myHostname) + ".local")) {
    Serial.println("Request redirected to captive portal");
    server.sendHeader("Location", String("http://") + toStringIp(server.client().localIP()), true);
    server.send(302, "text/plain", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
    server.client().stop(); // Stop is needed because we sent no content length
    return true;
  }
  return false;
}

///** Handle root or redirect to captive portal */
//void serveRoot() {
//  if (captivePortal()) { // If caprive portal redirect instead of displaying the page.
//    return;
//  }
//  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
//  server.sendHeader("Pragma", "no-cache");
//  server.sendHeader("Expires", "-1");
//  server.setContentLength(CONTENT_LENGTH_UNKNOWN);
//  server.send(200, "text/html", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
//  server.sendContent(
//    "<html><head></head><body>"
//    "<h1>HELLO WORLD!!</h1>"
// );
//  if (server.client().localIP() == apIP) {
//    server.sendContent(String("<p>You are connected through the soft AP: ") + softAP_ssid + "</p>");
//  } else {
//    server.sendContent(String("<p>You are connected through the wifi network: ") + ssid + "</p>");
//  }
//  server.sendContent(
//    "<p>You may want to <a href='/wifi'>config the wifi connection</a>.</p>");
//  server.sendContent("</body></html>");
//  server.client().stop(); // Stop is needed because we sent no content length
//}

/** Handle root or redirect to captive portal */
void serveRoot() {
  if (captivePortal()) { // If caprive portal redirect instead of displaying the page.
    return;
  }
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.setContentLength(CONTENT_LENGTH_UNKNOWN);
  server.send(200, "text/html", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
  server.sendContent(
    "<html><head><meta http-equiv='refresh' content='0; url=/wifi'></head><body></body></html>");
  server.client().stop(); // Stop is needed because we sent no content length
}

/** Wifi config page handler */
void serveWifi() {
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.setContentLength(CONTENT_LENGTH_UNKNOWN);
  server.send(200, "text/html", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
  server.sendContent(
    "<html><head></head><body>"
    "<h1>IOToilet Registration</h1>"
 );
  server.sendContent(
    "<form method='POST' action='wifisave'><h2>Connect to Wifi:</h2>"
    "<div style='font-size: 20pt'>Network: </div><input style='font-size: 20pt' type='text' placeholder='enter network name' name='n'/>"
    "<br/><br/><div style='font-size: 20pt'>Password: </div><input style='font-size: 20pt' type='password' placeholder='enter network password' name='p'/>"
    "<br/><br/><div style='font-size: 20pt'>Name: </div><input style='font-size: 20pt' type='text' placeholder='enter full name' name='fn'/>"
    "<br/><br/><div style='font-size: 20pt'>Phone: </div><input style='font-size: 20pt' type='text' placeholder='enter phone number' name='pn'/>"
    "<br/><br/><input style='font-size: 20pt' type='submit' value='Register'/></form>\r\n<br/>"
    // "<p>You may want to <a href='/'>return to the home page</a>.</p>"
 );
  if (server.client().localIP() == apIP) {
    server.sendContent(String("<p>You are connected through the soft AP: ") + softAP_ssid + "</p>");
  } else {
    server.sendContent(String("<p>You are connected through the wifi network: ") + ssid + "</p>");
  }
  server.sendContent("\r\n<br/>");
  server.sendContent("<table><tr><th align='left'>SoftAP config</th></tr>");
  server.sendContent(String() + "<tr><td>SSID " + String(softAP_ssid) + "</td></tr>");
  server.sendContent(String() + "<tr><td>IP " + toStringIp(WiFi.softAPIP()) + "</td></tr>");
  server.sendContent(
    "</table>"
    "\r\n<br/>"
    "<table><tr><th align='left'>WLAN config</th></tr>"
 );
  server.sendContent(String() + "<tr><td>SSID " + String(ssid) + "</td></tr>");
  server.sendContent(String() + "<tr><td>IP " + toStringIp(WiFi.localIP()) + "</td></tr>");
  server.sendContent("</table>\r\n<br/>");

  server.sendContent("<table><tr><th align='left'>WLAN list (refresh if any missing)</th></tr>");
  Serial.println("scan start");
  int n = WiFi.scanNetworks();
  Serial.println("scan done");
  if (n > 0) {
    for (int i = 0; i < n; i++) {
      server.sendContent(String() + "\r\n<tr><td>SSID " + WiFi.SSID(i) + String((WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : " *") + " (" + WiFi.RSSI(i) + ")</td></tr>");
    }
  } else {
    server.sendContent(String() + "<tr><td>No WLAN found</td></tr>");
  }
  server.sendContent(
    "</table>"
    "\r\n<br/>");
    
  server.sendContent("</body></html>");
  server.client().stop(); // Stop is needed because we sent no content length
}

/** Handle the WLAN save form and redirect to WLAN config page again */
void serveWifiSave() {
  DEBUG_PRINTLN("wifi save");
  server.arg("n").toCharArray(ssid, sizeof(ssid) - 1);
  server.arg("p").toCharArray(password, sizeof(password) - 1);
  url_encode(server.arg("fn")).toCharArray(full_name, sizeof(full_name) - 1);
  url_encode(server.arg("pn")).toCharArray(phone_number, sizeof(phone_number) - 1);
  DEBUG_PRINT("ssid: "); DEBUG_PRINTLN(ssid);
  DEBUG_PRINT("password: "); DEBUG_PRINTLN(password);
  DEBUG_PRINT("name: "); DEBUG_PRINTLN(full_name);
  DEBUG_PRINT("phone: "); DEBUG_PRINTLN(phone_number);
  server.sendHeader("Location", "/wifi", true);
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.send(200, "text/plain", "");  // Empty content inhibits Content-length header so we have to close the socket ourselves.
  server.sendContent("<html><body><h1>Thank you</h1></body></html>");
  server.client().stop(); // Stop is needed because we sent no content length
  eeprom_saveCredentials();
  eeprom_saveRegistration();
}

void serveNotFound() {
  if (captivePortal()) { // If captive portal redirect instead of displaying the error page.
    return;
  }
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message +=(server.method() == HTTP_GET) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";

  for(uint8_t i = 0; i < server.args(); i++) {
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.send(404, "text/plain", message);
}


void network_setup() {
  DEBUG_PRINTLN("Obtaining MAC address...");
  WiFi.macAddress(MAC_array);
  //MAC_array[0]=0xff;
  for (int i = 0; i < sizeof(MAC_array); ++i) {
    sprintf(MAC_char, "%s%02x", MAC_char, MAC_array[i]);
  }
}

void network_fireUpAP() {
  for (int i = 0; i < sizeof(MAC_char); ++i) {
    softAP_ssid[sizeof(softAP_ssid) - sizeof(MAC_char) + i] = (char)MAC_char[i];
  }
  Serial.print("Configuring access point ");
  Serial.print(softAP_ssid);
  Serial.println("...");
  long start = millis();
  /* You can remove the password parameter if you want the AP to be open. */
  WiFi.softAPConfig(apIP, apIP, netMsk);
  WiFi.softAP(softAP_ssid, softAP_password);
  delay(500); // Without delay I've seen the IP address blank
  Serial.print("Access Point IP address: ");
  Serial.println(WiFi.softAPIP());

  /* Setup the DNS server redirecting all the domains to the apIP */
  dnsServer.setErrorReplyCode(DNSReplyCode::NoError);
  dnsServer.start(DNS_PORT, "*", apIP);

  /* Setup web pages: root, wifi config pages, SO captive portal detectors and not found. */
  server.on("/", serveRoot);
  server.on("/wifi", serveWifi);
  server.on("/wifisave", serveWifiSave);
  server.on("/generate_204", serveRoot); // Android captive portal. Maybe not needed. Might be handled by notFound handler.
  server.on("/fwlink", serveRoot);       // Microsoft captive portal. Maybe not needed. Might be handled by notFound handler.
  server.onNotFound(serveNotFound);
  server.begin(); // Web server start
  Serial.print("Access Point startup time: ");
  Serial.print(millis() - start); Serial.println("ms.");
}



int network_connectWifi() {
  Serial.println("Connecting as wifi client...");
  WiFi.disconnect();
  status = WL_IDLE_STATUS;
  delay(1000);
  WiFi.begin(ssid, password);
  delay(1000);
  int connRes = WiFi.waitForConnectResult();
  Serial.print("connection result: ");
  Serial.println(connRes);
  return connRes;
}


/**
   Connect if needed, otherwise track wireless status and fire
   onConnected() and onDisonnected() callbacks
*/

// return a flag indicating whether status has changed
boolean network_updateWifiStatus() {
  int s = WiFi.status();
  if (status != s) { // WLAN status change
    DEBUG_PRINT("Wifi Status changed to: "); Serial.println(s);
    status = s;
    switch (s) {
      case WL_CONNECTED:       // 3
        is_connected = true;
        /* Just connected to WLAN */
        DEBUG_PRINT("Connected to "); DEBUG_PRINTLN(ssid); DEBUG_PRINT("IP address: "); DEBUG_PRINTLN(WiFi.localIP());
        if (!MDNS.begin(myHostname)) {
          DEBUG_PRINTLN("Error setting up MDNS responder!");
        }
        else {
          DEBUG_PRINTLN("mDNS responder started");
          // Add service to MDNS-SD
          MDNS.addService("http", "tcp", 80);
        }
        eeprom_setCredentialsValidity(CREDENTIALS_VALIDITY_PASS);
        break;
      case WL_CONNECTION_LOST: // 5
        WiFi.disconnect();
        is_connected = false;
        break;
      case WL_NO_SSID_AVAIL:   // 1
      case WL_CONNECT_FAILED:  // 4
      case WL_DISCONNECTED:    // 6
        WiFi.disconnect();
        is_connected = false;
        eeprom_setCredentialsValidity(CREDENTIALS_VALIDITY_FAIL);
        break;
    }
    return true;
  }
  return false;
}


void network_handleServers() {
  //DNS
  dnsServer.processNextRequest();
  //HTTP
  server.handleClient();
}

boolean network_isConnected() {
  // return WiFi.status() == WL_CONNECTED;
  return is_connected;
}

