#define SPEAKER_PIN D4

/*
// causes crashes, unfortunately
void _tone(uint8_t _pin, unsigned int frequency, unsigned long duration) {
  pinMode (_pin, OUTPUT );
  analogWriteFreq(frequency);
  analogWrite(_pin, 500);
  delay(duration);
  analogWrite(_pin, 0);
}
// - See more at: http://www.esp8266.com/viewtopic.php?f=29&t=7634#sthash.0CA47mEo.dpuf
*/


void _tone(uint8_t _pin, unsigned int frequency, unsigned long duration) {
  pinMode (_pin, OUTPUT );
  long start = millis();
  int us = int(1000000L/frequency);
  while((millis()-start) < duration) {
    digitalWrite(_pin, HIGH);
    delayMicroseconds(us);
    digitalWrite(_pin, LOW);
    delayMicroseconds(us);
  }
}


int wifi_success[4] = {523, 659, 783, 1046};
void play_wifi_success() {
  for(int i = 0; i < sizeof(wifi_success) / sizeof(int); ++i) {
    _tone(SPEAKER_PIN, wifi_success[i], 200);
    delay(50);
  }
}

int wifi_failure[4] = {1046, 783, 659, 523};
void play_wifi_failure() {
  for(int i = 0; i < sizeof(wifi_failure) / sizeof(int); ++i) {
    _tone(SPEAKER_PIN, wifi_failure[i], 200);
    delay(50);
  }
}

void play_triple_beep() {
  for(int i = 0; i < 3; ++i) {
    _tone(SPEAKER_PIN, 880, 50);
    delay(50);
  }
}

