/** Load WLAN credentials from EEPROM */
boolean loadCredentials() {
  EEPROM.begin(512);
  EEPROM.get(0, ssid);
  EEPROM.get(0+sizeof(ssid), password);
  char ok[2+1];
  EEPROM.get(0+sizeof(ssid)+sizeof(password), ok);
  EEPROM.end();
  if (String(ok) != String("OK")) {
    ssid[0] = 0;
    password[0] = 0;
    Serial.println("No credentials found");
    return false;
  }
  else {
    Serial.println("Recovered credentials:");
    Serial.println(ssid);
    Serial.println(strlen(password)>0?"********":"<no password>");
    return true;
  }
}

/** Store WLAN credentials to EEPROM */
void saveCredentials() {
  EEPROM.begin(512);
  EEPROM.put(0, ssid);
  EEPROM.put(0+sizeof(ssid), password);
  char ok[2+1] = "OK";
  EEPROM.put(0+sizeof(ssid)+sizeof(password), ok);
  EEPROM.commit();
  EEPROM.end();
}

void resetCredentials() {
  char ok[2+1] = "NO";
  EEPROM.put(0+sizeof(ssid)+sizeof(password), ok);
}

