/* Deep Sleep - Blink

   Blinks the onboard LED, and then goes into deep sleep until a switch is triggered

   Connections:

    |------(E)NPN(C)--- RST
    |         (B)
  SWITCH       |
    |        R = 10k
    |          |
   GND      D0(GPIO16)

  NPN transistor can be 3904 or 2N4401

*/

// sleep for this many seconds
const int sleepSeconds = 0; //0 = no wakeup

void setup() {
  pinMode(BUILTIN_LED, OUTPUT);
  pinMode(D0, WAKEUP_PULLUP);
  Serial.begin(9600);
  Serial.println("Start blinking");
  for (int i = 0; i < 20; i++)
  {
    digitalWrite(BUILTIN_LED, LOW); //LED: LOW = on
    delay(100);
    digitalWrite(BUILTIN_LED, HIGH); //LED: HIGH = off
    delay(100);
  }
  Serial.println("Stop blinking");
  Serial.printf("Sleep for %d seconds\n\n", sleepSeconds);
  ESP.deepSleep(sleepSeconds * 1000000); //convert to microseconds
}

void loop() {
}
