#include "I2Cdev.h"
#include "MPU6050.h"
#include "Wire.h"

#define RESET_ENABLE_PIN D0
#define GY521_ENABLE_PIN D5

MPU6050 accelgyro;

int16_t ax, ay, az;
int16_t gx, gy, gz;

boolean blinkState = false;

void setup() {
  Serial.begin(9600);
  pinMode(BUILTIN_LED, OUTPUT);
  pinMode(RESET_ENABLE_PIN, WAKEUP_PULLUP);
  pinMode(GY521_ENABLE_PIN, OUTPUT);
  digitalWrite(GY521_ENABLE_PIN, HIGH);
  delay(100);
  setup_acc();

  Serial.println("Start blinking");
  for (int i = 0; i < 1000; i++)
  {
    // read raw accel/gyro measurements from device
    accelgyro.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);

    // these methods (and a few others) are also available
    //accelgyro.getAcceleration(&ax, &ay, &az);
    //accelgyro.getRotation(&gx, &gy, &gz);

    //Serial.print("a/g:\t");
    Serial.print(ax); Serial.print("\t");
//    Serial.print(ay); Serial.print("\t");
    Serial.print(az); Serial.print("\t");
//    Serial.print(gx); Serial.print("\t");
//    Serial.print(gy); Serial.print("\t");
//    Serial.print(gz); Serial.print("\t");
    Serial.println();
    blinkState = !blinkState;
    digitalWrite(BUILTIN_LED, blinkState);
  }
  Serial.println("going to sleep");
  go_to_sleep();
}

void loop() {
}

void go_to_sleep() {
  // no need, happens automatically
  //digitalWrite(GY521_ENABLE_PIN, LOW);
  ESP.deepSleep(0); //convert to microseconds
}

void setup_acc() {
  Serial.println("Initializing I2C devices...");
  Wire.begin();
  accelgyro.initialize();

  // verify connection
  Serial.println("Testing device connections...");
  Serial.println(accelgyro.testConnection() ? "MPU6050 connection successful" : "MPU6050 connection failed");
}

