#include "I2Cdev.h"
#include "MPU6050.h"
#include "Wire.h"


#define TURN_STATE_COUNT 8
#define SENSOR_TOLERANCE 1000
#define MAX_TURN_SKIP 2

#define RESET_ENABLE_PIN D0
#define GY521_ENABLE_PIN D5

MPU6050 accelgyro;

int16_t ax, ay, az;
int16_t gx, gy, gz;

boolean blinkState = false;

void setup() {
  delay(500);
  Serial.begin(9600);
  pinMode(BUILTIN_LED, OUTPUT);
//  pinMode(RESET_ENABLE_PIN, WAKEUP_PULLUP);
  pinMode(RESET_ENABLE_PIN, OUTPUT);
  digitalWrite(RESET_ENABLE_PIN, LOW);
  pinMode(GY521_ENABLE_PIN, OUTPUT);
  digitalWrite(GY521_ENABLE_PIN, HIGH);
  delay(100);
  setup_acc();
}

void loop() {
  //accelgyro.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);
  accelgyro.getAcceleration(&ax, &ay, &az);
  Serial.print(ax); Serial.print("\t");
  Serial.print(ay); Serial.print("\t");
  Serial.print(az); Serial.print("\t");
  Serial.println();
  blinkState = !blinkState;
  digitalWrite(BUILTIN_LED, blinkState);
}

void setup_acc() {
  Serial.println("Initializing I2C devices...");
  Wire.begin();
  accelgyro.initialize();

  // verify connection
  Serial.println("Testing device connections...");
  Serial.println(accelgyro.testConnection() ? "MPU6050 connection successful" : "MPU6050 connection failed");
}
